OpenTTD: IndustryCargoesWindow Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Static Public Attributes
IndustryCargoesWindow Struct Reference

Window displaying the cargo connections around an industry (or cargo). More...

Inheritance diagram for IndustryCargoesWindow:

## Public Types
typedef SmallVector < CargoesRow, 4 > | Fields

## Public Member Functions
| IndustryCargoesWindow (int id)
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
void | ShortenCargoColumn (int column, int top, int bottom)
| Shorten the cargo column to just the part between industries.
void | PlaceIndustry (int row, int col, IndustryType it)
| Place an industry in the fields.
void | NotifySmallmap ()
| Notify smallmap that new displayed industries have been selected (in _displayed_industries).
void | ComputeIndustryDisplay (IndustryType it)
| Compute what and where to display for industry type it.
void | ComputeCargoDisplay (CargoID cid)
| Compute what and where to display for cargo id cid.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
bool | CalculatePositionInWidget (Point pt, Point *fieldxy, Point *xy)
| Calculate in which field was clicked, and within the field, at what position.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnHover (Point pt, int widget)
| The mouse is hovering over a widget in the window, perform an action for it, like opening a custom tooltip.
virtual void | OnResize ()
| Called after the window got resized.
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
void * | operator new[] (size_t size)
| Helper allocation function to disallow something.
void | operator delete (void *ptr)
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (uint widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (uint widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (uint widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (uint widnum)
| Return the querystring associated to a editbox.
virtual const char * | GetFocusedText () const
| Get the current input text if an edit box has the focus.
virtual const char * | GetCaret () const
| Get the string at the caret if an edit box has the focus.
virtual const char * | GetMarkedText (size_t *length) const
| Get the range of the currently marked input text.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual const char * | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree (bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (byte widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (byte widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (byte widget_index)
| Sets a widget to disabled.
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (byte widget_index)
| Marks a widget as lowered.
void | RaiseWidget (byte widget_index)
| Marks a widget as raised.
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (int widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (int wid, WChar key, uint16 keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (int wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, int widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets.
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets.
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
void | DeleteChildWindows (WindowClass wc=WC_INVALID) const
| Delete all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window looses focus.
virtual EventState | OnKeyPress (WChar key, uint16 keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnMouseDrag (Point pt, int widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (int widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Static Public Member Functions
static bool | HasCommonValidCargo (const CargoID *cargoes1, uint length1, const CargoID *cargoes2, uint length2)
| Do the two sets of cargoes have a valid cargo in common?
static bool | HousesCanSupply (const CargoID *cargoes, uint length)
| Can houses be used to supply one of the cargoes?
static bool | HousesCanAccept (const CargoID *cargoes, uint length)
| Can houses be used as customers of the produced cargoes?
static int | CountMatchingAcceptingIndustries (const CargoID *cargoes, uint length)
| Count how many industries have accepted cargoes in common with one of the supplied set.
static int | CountMatchingProducingIndustries (const CargoID *cargoes, uint length)
| Count how many industries have produced cargoes in common with one of the supplied set.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.

## Data Fields
Fields | fields
| Fields to display in the WID_IC_PANEL.
uint | ind_cargo
| If less than NUM_INDUSTRYTYPES, an industry type, else a cargo id + NUM_INDUSTRYTYPES.
Dimension | cargo_textsize
| Size to hold any cargo text, as well as STR_INDUSTRY_CARGOES_SELECT_CARGO.
Dimension | ind_textsize
| Size to hold any industry type text, as well as STR_INDUSTRY_CARGOES_SELECT_INDUSTRY.
Scrollbar * | vscroll
CargoesFieldType | type
| Type of field.
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
uint8 | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8 | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `NULL` if no nested widget has focus.
SmallMap< int, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
NWidgetBase * | nested_root
| Root of the nested tree.
NWidgetBase ** | nested_array
| Array of pointers into the tree. Do not access directly, use Window::GetWidget() instead.
uint | nested_array_size
| Size of the nested array.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `NULL`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
int | scrolling_scrollbar
| Widgetindex of just being dragged scrollbar. -1 if none is active.
Window * | parent
| Parent window.
Window * | z_front
| The window in front of us in z-order.
Window * | z_back
| The window behind us in z-order.

## Static Public Attributes
static const int | HOR_TEXT_PADDING = 5
| Horizontal padding around the industry type text.
static const int | VERT_TEXT_PADDING = 5
| Vertical padding around the industry type text.

## Additional Inherited Members
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
Protected Attributes inherited from Window
SmallVector< int, 4 > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.

## Detailed Description

Window displaying the cargo connections around an industry (or cargo).

The main display is constructed from 'fields', rectangles that contain an industry, piece of the cargo connection, cargo labels, or headers. For a nice display, the following should be kept in mind:

- A CFT_HEADER is always at the top of an column of CFT_INDUSTRY fields.
- A CFT_CARGO_LABEL field is also always put in a column of CFT_INDUSTRY fields.
- The top row contains CFT_HEADER and CFT_SMALL_EMPTY fields.
- Cargo connections have a column of their own (CFT_CARGO fields).
- Cargo accepted or produced by an industry, but not carried in a cargo connection, is drawn in the space of a cargo column attached to the industry. The information however is part of the industry.

This results in the following invariants:

- Width of a CFT_INDUSTRY column is large enough to hold all industry type labels, all cargo labels, and all header texts.
- Height of a CFT_INDUSTRY is large enough to hold a header line, or a industry type line, `N` cargo labels (where `N` is the maximum number of cargoes connected between industries), `N` connections of cargo types, and space between two industry types (1/2 above it, and 1/2 underneath it).
- Width of a cargo field (CFT_CARGO) is large enough to hold `N` vertical columns (one for each type of cargo). Also, space is needed between an industry and the leftmost/rightmost column to draw the non-carried cargoes.
- Height of a CFT_CARGO field is equally high as the height of the CFT_INDUSTRY.
- A field at the top (CFT_HEADER or CFT_SMALL_EMPTY) match the width of the fields below them (CFT_INDUSTRY respectively CFT_CARGO), the height should be sufficient to display the header text.

When displaying the cargoes around an industry type, five columns are needed (supplying industries, accepted cargoes, the industry, produced cargoes, customer industries). Displaying the industries around a cargo needs three columns (supplying industries, the cargo, customer industries). The remaining two columns are set to CFT_EMPTY with a width equal to the average of a cargo and an industry column.

Definition at line 2096 of file industry_gui.cpp.

## Member Function Documentation

bool IndustryCargoesWindow::CalculatePositionInWidget | ( | Point | pt,
|  | Point * | fieldxy,
|  | Point * | xy
| ) |  |
| inline

Calculate in which field was clicked, and within the field, at what position.

Parameters

  pt | Clicked position in the WID_IC_PANEL widget.
  fieldxy | If `true` is returned, field x/y coordinate of pt.
  xy | If `true` is returned, x/y coordinate with in the field.

Returns
  Clicked at a valid position.

Definition at line 2559 of file industry_gui.cpp.

References _current_text_dir, fields, Scrollbar::GetPosition(), ind_cargo, SmallVector< T, S >::Length(), NUM_INDUSTRYTYPES, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::resize_y, TD_RTL, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, WID_IC_PANEL, and Window::width.

Referenced by OnClick(), and OnHover().

void IndustryCargoesWindow::ComputeCargoDisplay | ( | CargoID | cid | ) |
| inline

Compute what and where to display for cargo id cid.

Parameters

  cid | Cargo id to display.

Definition at line 2424 of file industry_gui.cpp.

References _displayed_industries, IndustrySpec::accepts_cargo, SmallVector< T, S >::Append(), CeilDiv(), CFT_EMPTY, CFT_SMALL_EMPTY, SmallVector< T, S >::Clear(), CargoesRow::columns, CountMatchingAcceptingIndustries(), CountMatchingProducingIndustries(), IndustrySpec::enabled, fields, GetIndustrySpec(), HasCommonValidCargo(), HousesCanAccept(), HousesCanSupply(), ind_cargo, lengthof, CargoesField::MakeCargo(), CargoesField::MakeEmpty(), CargoesField::MakeHeader(), max(), NotifySmallmap(), NUM_INDUSTRYTYPES, PlaceIndustry(), NWidgetBase::resize_y, Scrollbar::SetCount(), Window::SetDirty(), ShortenCargoColumn(), WD_FRAMETEXT_BOTTOM, WD_FRAMETEXT_TOP, WID_IC_CAPTION, and WID_IC_PANEL.

Referenced by OnClick(), and OnDropdownSelect().

void IndustryCargoesWindow::ComputeIndustryDisplay | ( | IndustryType | it | ) |
| inline

Compute what and where to display for industry type it.

Parameters

  it | Industry type to display.

Definition at line 2345 of file industry_gui.cpp.

References _displayed_industries, IndustrySpec::accepts_cargo, SmallVector< T, S >::Append(), CeilDiv(), CFT_EMPTY, CFT_SMALL_EMPTY, SmallVector< T, S >::Clear(), CargoesRow::columns, CountMatchingAcceptingIndustries(), CountMatchingProducingIndustries(), IndustrySpec::enabled, fields, GetIndustrySpec(), HasCommonValidCargo(), HousesCanAccept(), HousesCanSupply(), ind_cargo, lengthof, CargoesField::MakeCargo(), CargoesField::MakeEmpty(), CargoesField::MakeHeader(), max(), NotifySmallmap(), NUM_INDUSTRYTYPES, PlaceIndustry(), NWidgetBase::resize_y, Scrollbar::SetCount(), Window::SetDirty(), ShortenCargoColumn(), WD_FRAMETEXT_BOTTOM, WD_FRAMETEXT_TOP, WID_IC_CAPTION, and WID_IC_PANEL.

Referenced by OnClick(), OnDropdownSelect(), and OnInvalidateData().

static int IndustryCargoesWindow::CountMatchingAcceptingIndustries | ( | const CargoID * | cargoes,
|  | uint | length
| ) |  |
| inlinestatic

Count how many industries have accepted cargoes in common with one of the supplied set.

Parameters

  cargoes | Cargoes to search.
  length | Number of cargoes in cargoes.

Returns
  Number of industries that have an accepted cargo in common with the supplied set.

Definition at line 2261 of file industry_gui.cpp.

References IndustrySpec::accepts_cargo, IndustrySpec::enabled, GetIndustrySpec(), HasCommonValidCargo(), lengthof, and NUM_INDUSTRYTYPES.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

static int IndustryCargoesWindow::CountMatchingProducingIndustries | ( | const CargoID * | cargoes,
|  | uint | length
| ) |  |
| inlinestatic

Count how many industries have produced cargoes in common with one of the supplied set.

Parameters

  cargoes | Cargoes to search.
  length | Number of cargoes in cargoes.

Returns
  Number of industries that have a produced cargo in common with the supplied set.

Definition at line 2279 of file industry_gui.cpp.

References IndustrySpec::enabled, GetIndustrySpec(), HasCommonValidCargo(), lengthof, and NUM_INDUSTRYTYPES.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

virtual void IndustryCargoesWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget
| ) |  | const
| inlinevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 2510 of file industry_gui.cpp.

References _current_text_dir, fields, FillDrawPixelInfo(), Scrollbar::GetPosition(), Window::height, ind_cargo, SmallVector< T, S >::Length(), NUM_INDUSTRYTYPES, NWidgetBase::resize_y, TD_RTL, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, WID_IC_PANEL, and Window::width.

static bool IndustryCargoesWindow::HasCommonValidCargo | ( | const CargoID * | cargoes1,
|  | uint | length1,
|  | const CargoID * | cargoes2,
|  | uint | length2
| ) |  |
| inlinestatic

Do the two sets of cargoes have a valid cargo in common?

Parameters

  cargoes1 | Base address of the first cargo array.
  length1 | Number of cargoes in the first cargo array.
  cargoes2 | Base address of the second cargo array.
  length2 | Number of cargoes in the second cargo array.

Returns
  Arrays have at least one valid cargo in common.

Definition at line 2197 of file industry_gui.cpp.

References INVALID_CARGO.

Referenced by ComputeCargoDisplay(), ComputeIndustryDisplay(), CountMatchingAcceptingIndustries(), and CountMatchingProducingIndustries().

static bool IndustryCargoesWindow::HousesCanAccept | ( | const CargoID * | cargoes,
|  | uint | length
| ) |  |
| inlinestatic

Can houses be used as customers of the produced cargoes?

Parameters

  cargoes | Base address of the cargo array.
  length | Number of cargoes in the array.

Returns
  Houses can accept at least one of the cargoes.

Definition at line 2230 of file industry_gui.cpp.

References _settings_game, HouseSpec::accepts_cargo, HouseSpec::building_availability, HouseSpec::cargo_acceptance, HouseSpec::enabled, GameSettings::game_creation, HZ_SUBARTC_ABOVE, HZ_SUBARTC_BELOW, HZ_SUBTROPIC, HZ_TEMP, HZ_TOYLND, INVALID_CARGO, GameCreationSettings::landscape, lengthof, and NUM_HOUSES.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

static bool IndustryCargoesWindow::HousesCanSupply | ( | const CargoID * | cargoes,
|  | uint | length
| ) |  |
| inlinestatic

Can houses be used to supply one of the cargoes?

Parameters

  cargoes | Base address of the cargo array.
  length | Number of cargoes in the array.

Returns
  Houses can supply at least one of the cargoes.

Definition at line 2215 of file industry_gui.cpp.

References INVALID_CARGO.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

virtual void IndustryCargoesWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count
| ) |  |
| inlinevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 2598 of file industry_gui.cpp.

References _settings_client, _sorted_industry_types, SmallVector< T, S >::Append(), CalculatePositionInWidget(), CargoesField::CargoClickedAt(), CargoesField::CargoLabelClickedAt(), CFT_CARGO, CFT_CARGO_LABEL, CFT_INDUSTRY, SoundSettings::click_beep, ComputeCargoDisplay(), ComputeIndustryDisplay(), IndustrySpec::enabled, fields, FindWindowByClass(), FOR_ALL_SORTED_STANDARD_CARGOSPECS, GetIndustrySpec(), ind_cargo, CargoSpec::Index(), CargoesField::industry, INVALID_CARGO, Window::IsWidgetLowered(), SmallVector< T, S >::Length(), CargoSpec::name, IndustrySpec::name, NotifySmallmap(), NUM_INDUSTRYTYPES, Window::SetWidgetDirty(), ShowDropDownList(), ShowSmallMap(), ClientSettings::sound, Window::ToggleWidgetLoweredState(), CargoesField::type, WC_SMALLMAP, WID_IC_CARGO_DROPDOWN, WID_IC_IND_DROPDOWN, WID_IC_NOTIFY, and WID_IC_PANEL.

virtual void IndustryCargoesWindow::OnDropdownSelect | ( | int | widget,
|  | int | index
| ) |  |
| inlinevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 2676 of file industry_gui.cpp.

References ComputeCargoDisplay(), ComputeIndustryDisplay(), WID_IC_CARGO_DROPDOWN, and WID_IC_IND_DROPDOWN.

virtual void IndustryCargoesWindow::OnHover | ( | Point | pt,
|  | int | widget
| ) |  |
| inlinevirtual

The mouse is hovering over a widget in the window, perform an action for it, like opening a custom tooltip.

Parameters

  pt | The point where the mouse is hovering.
  widget | The widget where the mouse is hovering.

Reimplemented from Window.

Definition at line 2691 of file industry_gui.cpp.

References CalculatePositionInWidget(), CargoesField::CargoClickedAt(), CargoesField::CargoLabelClickedAt(), CFT_CARGO, CFT_CARGO_LABEL, CFT_INDUSTRY, fields, CargoSpec::Get(), GuiShowTooltips(), ind_cargo, CargoesField::industry, INVALID_CARGO, CargoSpec::name, NUM_INDUSTRYTYPES, CargoesField::type, and WID_IC_PANEL.

virtual void IndustryCargoesWindow::OnInit | ( |  | ) |
| inlinevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or nested_array (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 2116 of file industry_gui.cpp.

References cargo_textsize, IndustrySpec::enabled, FONT_HEIGHT_NORMAL, CargoSpec::Get(), GetIndustrySpec(), GetStringBoundingBox(), HOR_TEXT_PADDING, ind_textsize, CargoSpec::IsValid(), max(), maxdim(), CargoSpec::name, IndustrySpec::name, NUM_CARGO, NUM_INDUSTRYTYPES, VERT_TEXT_PADDING, WD_FRAMETEXT_BOTTOM, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, and WD_FRAMETEXT_TOP.

virtual void IndustryCargoesWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlinevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data. data = 0 .. NUM_INDUSTRYTYPES - 1: Display the chain around the given industry. data = NUM_INDUSTRYTYPES: Stop sending updates to the smallmap window.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 2495 of file industry_gui.cpp.

References ComputeIndustryDisplay(), Window::IsWidgetLowered(), NUM_INDUSTRYTYPES, Window::RaiseWidget(), Window::SetWidgetDirty(), and WID_IC_NOTIFY.

virtual void IndustryCargoesWindow::OnResize | ( |  | ) |
| inlinevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 2730 of file industry_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_IC_PANEL.

void IndustryCargoesWindow::PlaceIndustry | ( | int | row,
|  | int | col,
|  | IndustryType | it
| ) |  |
| inline

Place an industry in the fields.

Parameters

  row | Row of the new industry.
  col | Column of the new industry.
  it | Industry to place.

Definition at line 2318 of file industry_gui.cpp.

References CFT_EMPTY, fields, and type.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

virtual void IndustryCargoesWindow::SetStringParameters | ( | int | widget | ) | const
| inlinevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 2176 of file industry_gui.cpp.

References CargoSpec::Get(), GetIndustrySpec(), ind_cargo, CargoSpec::name, IndustrySpec::name, NUM_INDUSTRYTYPES, SetDParam(), and WID_IC_CAPTION.

void IndustryCargoesWindow::ShortenCargoColumn | ( | int | column,
|  | int | top,
|  | int | bottom
| ) |  |
| inline

Shorten the cargo column to just the part between industries.

Parameters

  column | Column number of the cargo column.
  top | Current top row.
  bottom | Current bottom row.

Definition at line 2297 of file industry_gui.cpp.

References CFT_EMPTY, fields, and Window::top.

Referenced by ComputeCargoDisplay(), and ComputeIndustryDisplay().

virtual void IndustryCargoesWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize
| ) |  |
| inlinevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  widget | Widget number.
  size | Size of the widget.
  padding | Recommended amount of space between the widget content and the widget edge.
  fill | Fill step of the widget.
  resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 2157 of file industry_gui.cpp.

References max(), WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, WID_IC_CARGO_DROPDOWN, WID_IC_IND_DROPDOWN, and WID_IC_PANEL.

The documentation for this struct was generated from the following file:

- src/industry_gui.cpp